diff --git a/src/symbols.c b/src/symbols.c
index 65017de..971dcd9 100644
--- a/src/symbols.c
+++ b/src/symbols.c
@@ -1070,7 +1070,13 @@ static gchar *get_symbol_tooltip(GeanyDocument *doc, const TMTag *tag)
 	}
 
 	if (utf8_name != NULL)
-		setptr(utf8_name, g_markup_escape_text(utf8_name, -1));
+	{
+		/* Invalid UTF-8 can be in utf8_name, so make sure it's valid
+		 * before escaping, otherwise skip. This prevents a segfault on
+		 * bad UTF-8. */
+		if (g_utf8_validate(utf8_name, -1, NULL))
+			setptr(utf8_name, g_markup_escape_text(utf8_name, -1));
+	}
 
 	return utf8_name;
 }
